# Float to BMS Gauge conversion
#
# Copyright (c) 2015 Texas Instruments
#
# Version 1.0
#
import sys, os, math

usage = "usage: python IEEErealtoGauge.py  afloatNum"
if len(sys.argv) != 2:
	print usage
	sys.exit(1)

afloat = float(sys.argv[1])
print "Note: abs(afloatNum) must be between 1**-38 and 1**38"
print " for this conversion to be valid"
print "Converting", afloat
	
# deal with sign
sign = 0
if 0.0 > afloat:
	sign = 0x80
	afloat = -afloat

print "Now have: ", afloat

#first the exponent
newexp = int((math.log10(afloat)/math.log10(2)) + 129)
# mantissa
newmtsa = int(afloat * math.pow(.5, (newexp - 24 - 128)))
print "newexp: ", newexp # this is sb4
print "newmtsa: ", newmtsa
# MSB -> LSB order
# note that the leading 1 (msb) in the MSB is going to be implied and thus the bit can be used for a sign bit
#  gives one more bit of precision
sb3 = (((newmtsa /(256*256))&0x7f) | sign)
sb2 = (newmtsa / (256)) & 0xff
sb1 = newmtsa & 0xff
print "Gauge Hex MSB -> LSB: ", hex(newexp), hex(sb3), hex(sb2), hex(sb1)
